
' Note: To run this inside Visual Studio, you will need to:
' Project / Properties / Debug / Uncheck Enable the Visual Studio hosting process

' USAGE
' Dim Kb_OnOff As New KeyboardOnOff()
' Kb_OnOff.SetKeyboardHook()
' Kb_OnOff.ReleaseKeyboardHook()

Imports System.Runtime.InteropServices
Imports System.Reflection.Assembly

Friend Class KeyboardOnOff

    Private hhkLowLevelKybd As Integer

    Private Const HC_ACTION As Integer = 0
    Private Const WH_KEYBOARD_LL As Integer = 13
    Private Const WM_KEYDOWN As Integer = &H100
    Private Const WM_KEYUP As Integer = &H101
    Private Const WM_SYSKEYDOWN As Integer = &H104
    Private Const WM_SYSKEYUP As Integer = &H105

    Private Structure KBDLLHOOKSTRUCT
        Public vkCode As Integer
        Public scanCode As Integer
        Public flags As Integer
        Public time As Integer
        Public dwExtraInfo As Integer
    End Structure

    Private Declare Function SetWindowsHookEx Lib "user32" _
                                        Alias "SetWindowsHookExA" ( _
                                        ByVal idHook As Integer, _
                                        ByVal lpfn As LowLevelKeyboardProcDelegate, _
                                        ByVal hmod As Integer, _
                                        ByVal dwThreadId As Integer) As Integer

    Private Declare Function CallNextHookEx Lib "user32" ( _
                                        ByVal hHook As Integer, _
                                        ByVal nCode As Integer, _
                                        ByVal wParam As Integer, _
                                        ByVal lParam As KBDLLHOOKSTRUCT) As Integer

    Private Declare Function UnhookWindowsHookEx Lib "user32" _
                                        (ByVal hHook As Integer) As Integer


    Private KeyboardHookDelegate As LowLevelKeyboardProcDelegate

    Private Delegate Function LowLevelKeyboardProcDelegate(ByVal nCode As Integer, _
                                                           ByVal wParam As Integer, _
                                                           ByRef lParam As KBDLLHOOKSTRUCT) As Integer

    Private Function LowLevelKeyboardProc(ByVal nCode As Integer, _
                                          ByVal wParam As Integer, _
                                          ByRef lParam As KBDLLHOOKSTRUCT) As Integer

        If (nCode = HC_ACTION) Then

            If wParam = WM_KEYDOWN Or _
               wParam = WM_SYSKEYDOWN Or _
               wParam = WM_KEYUP Or _
               wParam = WM_SYSKEYUP Then

                If KeyboardEnabled Then
                    DisableCounter = 0
                Else
                    If wParam = WM_KEYUP Then
                        TestPassword(lParam.vkCode)
                    End If
                    Return 1
                End If
            End If
        End If
        Return CallNextHookEx(hhkLowLevelKybd, nCode, wParam, lParam)
    End Function

    Friend Password As String = "PASS"
    Private PasswordIndex As Int32 = 1
    Private WithEvents timer1 As Timer = New Timer
    Private Sub TestPassword(ByVal code As Int32)
        If Password.Length = 0 Then Return
        If code = AscW(Strings.Mid(Password.ToUpper, PasswordIndex, 1)) Then
            PasswordIndex += 1
        Else
            PasswordIndex = 1
        End If
        If PasswordIndex > Password.Length Then
            PasswordIndex = 1
            DisableCounter = -1
        Else
            timer1.Interval = 2000
            timer1.Stop()
            timer1.Start()
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timer1.Tick
        timer1.Stop()
        PasswordIndex = 1
    End Sub

    Friend Sub SetKeyboardHook()
        KeyboardHookDelegate = New LowLevelKeyboardProcDelegate(AddressOf LowLevelKeyboardProc)
        hhkLowLevelKybd = SetWindowsHookEx(WH_KEYBOARD_LL, _
                                           KeyboardHookDelegate, _
                                           Marshal.GetHINSTANCE( _
                                           GetExecutingAssembly.GetModules()(0)).ToInt32, _
                                           0)
    End Sub

    Friend Sub ReleaseKeyboardHook()
        UnhookWindowsHookEx(hhkLowLevelKybd)
    End Sub

End Class



